# Terraform AWS Cloudwatch Monitoring

<!-- BEGINNING OF PRE-COMMIT-TERRAFORM DOCS HOOK -->
## Requirements

No requirements.

## Providers

| Name | Version |
|------|---------|
| aws | n/a |

## Inputs

| Name | Description | Type | Default | Required |
|------|-------------|------|---------|:--------:|
| api\_gateway\_default\_thresholds | Default thresholds for API Gateway functions. | `map` | <pre>{<br>  "casual": {<br>    "enabled": true,<br>    "evaluation_period_count": 5,<br>    "evaluation_period_seconds": 60,<br>    "max_4xx_error_rate_percent": 20,<br>    "max_5xx_error_rate_percent": 5,<br>    "max_integration_latency_millis": 1500,<br>    "max_latency_millis": 1500<br>  },<br>  "urgent": {<br>    "enabled": true,<br>    "evaluation_period_count": 5,<br>    "evaluation_period_seconds": 60,<br>    "max_4xx_error_rate_percent": 40,<br>    "max_5xx_error_rate_percent": 10,<br>    "max_integration_latency_millis": 3000,<br>    "max_latency_millis": 3000<br>  }<br>}</pre> | no |
| api\_gateways | A map of api gateways which Cloudwatch alarms should be setup for. | `list(any)` | `[]` | no |
| casual\_sns\_topic\_arn | SNS topic ARN for sending casual (nonurgent) alarms to. | `string` | n/a | yes |
| datapoints\_to\_alarm | The number of datapoints that must be breaching to trigger the alarm. | `string` | `""` | no |
| dynamo\_db\_account\_defaults | Account level defaults for DynamoDB alarms | <pre>object({<br>    urgent = object({<br>      enabled                              = bool<br>      throughput_threshold_percent         = number<br>      throughput_evaluation_period_seconds = number<br>      throughput_evaluation_period_count   = number<br>      throughput_missing_data              = string<br>    })<br>    casual = object({<br>      enabled                              = bool<br>      throughput_threshold_percent         = number<br>      throughput_evaluation_period_seconds = number<br>      throughput_evaluation_period_count   = number<br>      throughput_missing_data              = string<br>    })<br>    common = object({<br>      throughput_alarm_name        = string<br>      throughput_alarm_description = string<br>    })<br>  })</pre> | <pre>{<br>  "casual": {<br>    "enabled": true,<br>    "throughput_evaluation_period_count": 5,<br>    "throughput_evaluation_period_seconds": 300,<br>    "throughput_missing_data": "notBreaching",<br>    "throughput_threshold_percent": 70<br>  },<br>  "common": {<br>    "throughput_alarm_description": "DynamoDB throughput is high - limits may be reached.",<br>    "throughput_alarm_name": "Dynamo-Throughput"<br>  },<br>  "urgent": {<br>    "enabled": true,<br>    "throughput_evaluation_period_count": 5,<br>    "throughput_evaluation_period_seconds": 300,<br>    "throughput_missing_data": "notBreaching",<br>    "throughput_threshold_percent": 80<br>  }<br>}</pre> | no |
| dynamo\_db\_table\_defaults | Table level defaults for DynamoDB alarms | <pre>object({<br>    urgent = object({<br>      enabled                                = bool<br>      system_error_threshold                 = number<br>      system_error_evaluation_period_seconds = number<br>      system_error_evaluation_period_count   = number<br>      system_error_missing_data              = string<br><br>      latency_threshold_ms              = number<br>      latency_evaluation_period_seconds = number<br>      latency_evaluation_period_count   = number<br>      latency_missing_data              = string<br><br>      throughput_threshold                 = number<br>      throughput_evaluation_period_seconds = number<br>      throughput_evaluation_period_count   = number<br>      throughput_missing_data              = string<br>    })<br>    casual = object({<br>      enabled                                = bool<br>      system_error_threshold                 = number<br>      system_error_evaluation_period_seconds = number<br>      system_error_evaluation_period_count   = number<br>      system_error_missing_data              = string<br><br>      latency_threshold_ms              = number<br>      latency_evaluation_period_seconds = number<br>      latency_evaluation_period_count   = number<br>      latency_missing_data              = string<br><br>      throughput_threshold                 = number<br>      throughput_evaluation_period_seconds = number<br>      throughput_evaluation_period_count   = number<br>      throughput_missing_data              = string<br>    })<br>    common = object({<br>      system_error_alarm_name        = string<br>      system_error_alarm_description = string<br><br>      latency_alarm_name        = string<br>      latency_alarm_description = string<br>    })<br>  })</pre> | <pre>{<br>  "casual": {<br>    "enabled": true,<br>    "latency_evaluation_period_count": 5,<br>    "latency_evaluation_period_seconds": 60,<br>    "latency_missing_data": "notBreaching",<br>    "latency_threshold_ms": 150,<br>    "system_error_evaluation_period_count": 5,<br>    "system_error_evaluation_period_seconds": 60,<br>    "system_error_missing_data": "notBreaching",<br>    "system_error_threshold": 5,<br>    "throughput_evaluation_period_count": 5,<br>    "throughput_evaluation_period_seconds": 60,<br>    "throughput_missing_data": "notBreaching",<br>    "throughput_threshold": 1000<br>  },<br>  "common": {<br>    "latency_alarm_description": "DynamoDB latency too high",<br>    "latency_alarm_name": "Dynamo-Latency",<br>    "system_error_alarm_description": "DynamoDB table system errors too high",<br>    "system_error_alarm_name": "Dynamo-SystemErrors"<br>  },<br>  "urgent": {<br>    "enabled": true,<br>    "latency_evaluation_period_count": 5,<br>    "latency_evaluation_period_seconds": 60,<br>    "latency_missing_data": "notBreaching",<br>    "latency_threshold_ms": 250,<br>    "system_error_evaluation_period_count": 5,<br>    "system_error_evaluation_period_seconds": 60,<br>    "system_error_missing_data": "notBreaching",<br>    "system_error_threshold": 10,<br>    "throughput_evaluation_period_count": 5,<br>    "throughput_evaluation_period_seconds": 60,<br>    "throughput_missing_data": "notBreaching",<br>    "throughput_threshold": 10000<br>  }<br>}</pre> | no |
| dynamo\_db\_tables | List of DynamoDB tables which Cloudwatch alarms should be setup for. | `list(any)` | `[]` | no |
| efs\_default\_thresholds | Default thresholds for EFS volumes. | <pre>object({<br>    urgent = object({<br>      enabled                  = bool<br>      min_burst_credit_balance = number<br>    })<br>    casual = object({<br>      enabled                  = bool<br>      min_burst_credit_balance = number<br>    })<br>  })</pre> | <pre>{<br>  "casual": {<br>    "enabled": true,<br>    "min_burst_credit_balance": 1500000000000<br>  },<br>  "urgent": {<br>    "enabled": true,<br>    "min_burst_credit_balance": 1000000000000<br>  }<br>}</pre> | no |
| efs\_volumes | List of maps containing EFS volumes which Cloudwatch alarms should be setup for. | `list(any)` | `[]` | no |
| elasticsearch | List of maps containing elasticsearch clusters which Cloudwatch alarms should be setup for. | `list(any)` | `[]` | no |
| elasticsearch\_default\_thresholds | Default thresholds for Elasticsearch clusters. | <pre>object({<br>    urgent = object({<br>      enabled                            = bool<br>      min_free_storage_space             = number<br>      max_cpu_utilization                = number<br>      max_jvm_memory_pressure            = number<br>      cluster_yellow_evaluation_periods  = number<br>      cluster_yellow_datapoints_to_alarm = number<br>      cluster_red_evaluation_periods     = number<br>      cluster_red_datapoints_to_alarm    = number<br>    })<br>    casual = object({<br>      enabled                            = bool<br>      min_free_storage_space             = number<br>      max_cpu_utilization                = number<br>      max_jvm_memory_pressure            = number<br>      cluster_yellow_evaluation_periods  = number<br>      cluster_yellow_datapoints_to_alarm = number<br>      cluster_red_evaluation_periods     = number<br>      cluster_red_datapoints_to_alarm    = number<br>    })<br>    # AWS account ID where the Elasticsearch cluster resides<br>    client_id = string<br>  })</pre> | <pre>{<br>  "casual": {<br>    "cluster_red_datapoints_to_alarm": 1,<br>    "cluster_red_evaluation_periods": 1,<br>    "cluster_yellow_datapoints_to_alarm": 1,<br>    "cluster_yellow_evaluation_periods": 1,<br>    "enabled": true,<br>    "max_cpu_utilization": 80,<br>    "max_jvm_memory_pressure": 80,<br>    "min_free_storage_space": 20000<br>  },<br>  "client_id": "",<br>  "urgent": {<br>    "cluster_red_datapoints_to_alarm": 1,<br>    "cluster_red_evaluation_periods": 1,<br>    "cluster_yellow_datapoints_to_alarm": 1,<br>    "cluster_yellow_evaluation_periods": 1,<br>    "enabled": true,<br>    "max_cpu_utilization": 90,<br>    "max_jvm_memory_pressure": 90,<br>    "min_free_storage_space": 10000<br>  }<br>}</pre> | no |
| enable\_casual | Set true to enable casual alarms. | `bool` | `true` | no |
| enable\_urgent | Set true to enable urgent alarms. | `bool` | `false` | no |
| lambda | List of maps containing api gateways which Cloudwatch alarms should be setup for. | `list(any)` | `[]` | no |
| lambda\_default\_thresholds | Default thresholds for Lambda functions. | <pre>object({<br>    urgent = object({<br>      enabled                = bool<br>      max_error_rate_percent = number<br>      max_duration_percent   = number<br>      max_5m_throttle_rate   = number<br>    })<br>    casual = object({<br>      enabled                = bool<br>      max_error_rate_percent = number<br>      max_duration_percent   = number<br>      max_5m_throttle_rate   = number<br>    })<br>  })</pre> | <pre>{<br>  "casual": {<br>    "enabled": true,<br>    "max_5m_throttle_rate": 5,<br>    "max_duration_percent": 80,<br>    "max_error_rate_percent": 5<br>  },<br>  "urgent": {<br>    "enabled": true,<br>    "max_5m_throttle_rate": 10,<br>    "max_duration_percent": 95,<br>    "max_error_rate_percent": 10<br>  }<br>}</pre> | no |
| lb | List of maps containing load balancer names which Cloudwatch alarms should be setup for. | `list(any)` | `[]` | no |
| lb\_defaults | Defaults for LBs. | <pre>object({<br>    urgent = object({<br>      enabled                = bool<br>      max_error_rate_percent = number<br><br>    })<br>    casual = object({<br>      enabled                = bool<br>      max_error_rate_percent = number<br>    })<br>    type = string<br>  })</pre> | <pre>{<br>  "casual": {<br>    "enabled": true,<br>    "max_error_rate_percent": 5<br>  },<br>  "type": "alb",<br>  "urgent": {<br>    "enabled": true,<br>    "max_error_rate_percent": 10<br>  }<br>}</pre> | no |
| name\_prefix | Arbitrary string to keep names unique. | `string` | `""` | no |
| rds\_clusters | A map containing RDS clusters which Cloudwatch alarms should be setup for. | `list(any)` | `[]` | no |
| rds\_clusters\_default\_thresholds | Default thresholds for RDS databases. | <pre>object({<br>    urgent = object({<br>      enabled                                      = bool<br>      reader_connections_count_threshold           = number<br>      reader_connections_evaluation_period_seconds = number<br>      reader_connections_evaluation_periods_count  = number<br>      reader_cpu_evaluation_period_seconds         = number<br>      reader_cpu_evaluation_periods_count          = number<br>      reader_cpu_threshold_percent                 = number<br>      replica_lag_evaluation_period_seconds        = number<br>      replica_lag_evaluation_periods_count         = number<br>      replica_lag_threshold_millis                 = number<br>      writer_connections_count_threshold           = number<br>      writer_connections_evaluation_period_seconds = number<br>      writer_connections_evaluation_periods_count  = number<br>      writer_cpu_evaluation_period_seconds         = number<br>      writer_cpu_evaluation_periods_count          = number<br>      writer_cpu_threshold_percent                 = number<br>    })<br>    casual = object({<br>      enabled                                      = bool<br>      reader_connections_count_threshold           = number<br>      reader_connections_evaluation_period_seconds = number<br>      reader_connections_evaluation_periods_count  = number<br>      reader_cpu_evaluation_period_seconds         = number<br>      reader_cpu_evaluation_periods_count          = number<br>      reader_cpu_threshold_percent                 = number<br>      replica_lag_evaluation_period_seconds        = number<br>      replica_lag_evaluation_periods_count         = number<br>      replica_lag_threshold_millis                 = number<br>      writer_connections_count_threshold           = number<br>      writer_connections_evaluation_period_seconds = number<br>      writer_connections_evaluation_periods_count  = number<br>      writer_cpu_evaluation_period_seconds         = number<br>      writer_cpu_evaluation_periods_count          = number<br>      writer_cpu_threshold_percent                 = number<br>    })<br>  })</pre> | <pre>{<br>  "casual": {<br>    "enabled": true,<br>    "reader_connections_count_threshold": 500,<br>    "reader_connections_evaluation_period_seconds": 60,<br>    "reader_connections_evaluation_periods_count": 1,<br>    "reader_cpu_evaluation_period_seconds": 60,<br>    "reader_cpu_evaluation_periods_count": 1,<br>    "reader_cpu_threshold_percent": 85,<br>    "replica_lag_evaluation_period_seconds": 60,<br>    "replica_lag_evaluation_periods_count": 1,<br>    "replica_lag_threshold_millis": 100,<br>    "writer_connections_count_threshold": 500,<br>    "writer_connections_evaluation_period_seconds": 60,<br>    "writer_connections_evaluation_periods_count": 1,<br>    "writer_cpu_evaluation_period_seconds": 60,<br>    "writer_cpu_evaluation_periods_count": 1,<br>    "writer_cpu_threshold_percent": 85<br>  },<br>  "urgent": {<br>    "enabled": true,<br>    "reader_connections_count_threshold": 1000,<br>    "reader_connections_evaluation_period_seconds": 60,<br>    "reader_connections_evaluation_periods_count": 1,<br>    "reader_cpu_evaluation_period_seconds": 60,<br>    "reader_cpu_evaluation_periods_count": 1,<br>    "reader_cpu_threshold_percent": 95,<br>    "replica_lag_evaluation_period_seconds": 60,<br>    "replica_lag_evaluation_periods_count": 1,<br>    "replica_lag_threshold_millis": 100,<br>    "writer_connections_count_threshold": 500,<br>    "writer_connections_evaluation_period_seconds": 60,<br>    "writer_connections_evaluation_periods_count": 1,<br>    "writer_cpu_evaluation_period_seconds": 60,<br>    "writer_cpu_evaluation_periods_count": 1,<br>    "writer_cpu_threshold_percent": 95<br>  }<br>}</pre> | no |
| rds\_instances | A list of maps containing RDS instances which Cloudwatch alarms should be setup for. | `list(any)` | `[]` | no |
| rds\_instances\_default\_thresholds | Default thresholds for RDS instances. | <pre>object({<br>    urgent = object({<br>      enabled                               = bool<br>      connections_evaluation_period_seconds = number<br>      connections_evaluation_periods_count  = number<br>      connections_count_threshold           = number<br>      cpu_evaluation_period_seconds         = number<br>      cpu_evaluation_periods_count          = number<br>      cpu_threshold_percent                 = number<br>      disk_space_evaluation_period_seconds  = number<br>      disk_space_evaluation_periods_count   = number<br>      min_free_storage_percent              = number<br>    })<br>    casual = object({<br>      enabled                               = bool<br>      connections_evaluation_period_seconds = number<br>      connections_evaluation_periods_count  = number<br>      connections_count_threshold           = number<br>      cpu_evaluation_period_seconds         = number<br>      cpu_evaluation_periods_count          = number<br>      cpu_threshold_percent                 = number<br>      disk_space_evaluation_period_seconds  = number<br>      disk_space_evaluation_periods_count   = number<br>      min_free_storage_percent              = number<br>    })<br>  })</pre> | <pre>{<br>  "casual": {<br>    "connections_count_threshold": 500,<br>    "connections_evaluation_period_seconds": 60,<br>    "connections_evaluation_periods_count": 1,<br>    "cpu_evaluation_period_seconds": 60,<br>    "cpu_evaluation_periods_count": 5,<br>    "cpu_threshold_percent": 85,<br>    "disk_space_evaluation_period_seconds": 60,<br>    "disk_space_evaluation_periods_count": 5,<br>    "enabled": true,<br>    "min_free_storage_percent": 15<br>  },<br>  "urgent": {<br>    "connections_count_threshold": 1000,<br>    "connections_evaluation_period_seconds": 60,<br>    "connections_evaluation_periods_count": 1,<br>    "cpu_evaluation_period_seconds": 60,<br>    "cpu_evaluation_periods_count": 5,<br>    "cpu_threshold_percent": 95,<br>    "disk_space_evaluation_period_seconds": 60,<br>    "disk_space_evaluation_periods_count": 5,<br>    "enabled": true,<br>    "min_free_storage_percent": 5<br>  }<br>}</pre> | no |
| redis | List of maps containing redis nodes which Cloudwatch alarms should be setup for. | `list(any)` | `[]` | no |
| redis\_default\_thresholds | Default thresholds for Redis node. | <pre>object({<br>    urgent = object({<br>      enabled                = bool<br>      max_engine_cpu_percent = number<br>      max_cpu_percent        = number<br>      min_freeable_mem_bytes = number<br>    })<br>    casual = object({<br>      enabled                = bool<br>      max_engine_cpu_percent = number<br>      max_cpu_percent        = number<br>      min_freeable_mem_bytes = number<br>    })<br>  })</pre> | <pre>{<br>  "casual": {<br>    "enabled": true,<br>    "max_cpu_percent": 75,<br>    "max_engine_cpu_percent": 75,<br>    "min_freeable_mem_bytes": 536870912<br>  },<br>  "urgent": {<br>    "enabled": true,<br>    "max_cpu_percent": 90,<br>    "max_engine_cpu_percent": 90,<br>    "min_freeable_mem_bytes": 268435456<br>  }<br>}</pre> | no |
| sqs | List of maps containing SQS queue which Cloudwatch alarms should be setup for. | `list` | `[]` | no |
| sqs\_defaults | Default thresholds for SQS queue. | <pre>object({<br>    urgent = object({<br>      enabled                  = bool<br>      oldest_message_seconds   = number<br>      inflight_message_percent = number<br>      max_message_size_percent = number<br>    })<br>    casual = object({<br>      enabled                  = bool<br>      oldest_message_seconds   = number<br>      inflight_message_percent = number<br>      max_message_size_percent = number<br>    })<br>    type = string<br>  })</pre> | <pre>{<br>  "casual": {<br>    "enabled": true,<br>    "inflight_message_percent": 85,<br>    "max_message_size_percent": 95,<br>    "oldest_message_seconds": 3600<br>  },<br>  "type": "normal",<br>  "urgent": {<br>    "enabled": true,<br>    "inflight_message_percent": 95,<br>    "max_message_size_percent": 100,<br>    "oldest_message_seconds": 7200<br>  }<br>}</pre> | no |
| urgent\_sns\_topic\_arn | SNS topic ARN for sending urgent alarms to. | `string` | n/a | yes |

## Outputs

| Name | Description |
|------|-------------|
| local\_sqs | n/a |

<!-- END OF PRE-COMMIT-TERRAFORM DOCS HOOK -->
